# UTILITIES
import csv
from array import * 
from datetime import datetime

# NLP STUFF
import nltk
from nltk import word_tokenize
from nltk.stem.wordnet import WordNetLemmatizer
from nltk.probability import FreqDist
lmtzr = WordNetLemmatizer()

class Item(object):
    #date, time, count, subjects, titles
    
    def __init__(self, d, c, s):
        self.datetime = d
        self.count = c
        self.subjects = s


def getFrequencyList(sentence):
    # TOKEN EXTRACTION
    tokens = nltk.word_tokenize(sentence)
	
    # CONVERT LOWERCASE
    tokens = [w.lower() for w in tokens]
    
    # LEMMATIZATION
    lemmatized = []
    for x in range(len(tokens)):
        lemmatized.append(lmtzr.lemmatize(tokens[x]))

    # FREQUENCY
    fdist1 = FreqDist(lemmatized)
    return fdist1.most_common(len(fdist1))
    # returns as [(',', 18713), ('the', 13721), ...

theArray = []
with open('words_05_17.csv', 'rt', encoding='utf-8') as csvfile:
    csvreader = csv.reader(csvfile, delimiter=',')
         
    try:
        for row in csvreader:
            if(row[0] != 'date'):            
                print("%s %s:00"%(row[0],row[1]))
                dt = datetime.strptime("%s %s:00"%(row[0],row[1]),'%Y-%m-%d %H:00')
                subject = ''
                for x in getFrequencyList(row[3]):
                    subject += "%s %s#"%(x[0], x[1])
                i = Item(dt, int(row[2]), subject)
                theArray.append(i)
    except UnicodeDecodeError:
        print("wrong read...")
    except UnicodeEncodeError:
        print("wrong read...")
        
with open('nltk_05_17.csv', 'wt', encoding='utf-8') as csvfile:
    csvwriter = csv.writer(csvfile)
    for x in range(len(theArray)):
        csvwriter.writerow([theArray[x].datetime, theArray[x].count, theArray[x].subjects])