// ControlP5 control event
void controlEvent(ControlEvent theControlEvent) {
  if(theControlEvent.isFrom("range_freq")) {
    sliderMinMeanFrequency = theControlEvent.getController().getArrayValue(0);
    sliderMaxMeanFrequency = theControlEvent.getController().getArrayValue(1);
  }
  else if(theControlEvent.isFrom("range_wind")) {
    sliderMinMeanWind = theControlEvent.getController().getArrayValue(0);
    sliderMaxMeanWind = theControlEvent.getController().getArrayValue(1);
  }
  else if(theControlEvent.isFrom("range_temp")) {
    sliderMinMeanTemp = theControlEvent.getController().getArrayValue(0);
    sliderMaxMeanTemp = theControlEvent.getController().getArrayValue(1);
  }
  else if(theControlEvent.isFrom("Temperature View")) {
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,0.,1.), 0), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  }
  else if(theControlEvent.isFrom("Frequency View")) {
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,1.,0.), HALF_PI), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  }
  else if(theControlEvent.isFrom("Date View")) {
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,0.,1.), 3*HALF_PI), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  }
  else if(theControlEvent.isFrom("Toggle Auto Rotation")) {
    autorotate = !autorotate;
  }
  else if(theControlEvent.isFrom("Invert Colors")) {
    changeColors();
  }
  else if(theControlEvent.isFrom("Toggle Color Search")) {
    useColors = !useColors;
  }
}

void keyPressed(KeyEvent e){
  if (e.isControlDown() && e.getKey() == 16) {//ctrl+p
    save(year()+"-"+month()+"-"+day()+" "+
      hour()+"_"+minute()+"_"+second()+".png");
  }
  
  // x-y plane
  if(key == '1'){
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,0.,1.), 0), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  } 
  // y-z plane
  else if(key == '2'){
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,1.,0.), HALF_PI), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  } 
  // x-z plane
  else if(key == '3'){
    cam.setState(new CameraState(new Rotation(new Vector3D(0.,0.,1.), 3*HALF_PI), // rotation
                              new Vector3D(500, 500, 500), // lookat
                              1500), // distance
              1000); // animation time
  }
  else if(key == '0'){
    changeColors();
  }
  else if(key == '9') {
    autorotate = !autorotate;
  }
  else if(key == '8') {
    useColors = !useColors;
  }
  // initiates text input
  else if((key >= 'a' && key <= 'z') || keyCode == BACKSPACE || key == ' '){
    cp5.get(Textfield.class, "input").setFocus(true);
  }
}

void changeColors(){
    foreground = color(255-red(foreground), 255-blue(foreground), 255-green(foreground));
    background = color(255-red(background), 255-blue(background), 255-green(background));
    
    cp5.get(Textfield.class, "input")
      .setColor(background)
      .setColorActive(color(foreground))
      .setColorBackground(color(foreground, 200))
      .setColorForeground(background)
      .setColorCaptionLabel(foreground)
      .setColorCursor(background);
    cp5.get(ScrollableList.class, "dropdown")
     .setColorActive(color(foreground))
     .setColorBackground(color(foreground, 200))
     .setColorForeground(background)
     .setColorCaptionLabel(foreground)
     .setColorValue(background);     
   cp5.get(Range.class, "range_temp")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorValue(lerpColor(background, foreground, 0.3))
     .setColorValueLabel(lerpColor(background, foreground, 0.3))
     .setColorCaptionLabel(foreground);
   cp5.get(Range.class, "range_wind")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorValue(lerpColor(background, foreground, 0.3))
     .setColorValueLabel(lerpColor(background, foreground, 0.3))
     .setColorCaptionLabel(foreground);
   cp5.get(Range.class, "range_freq")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorValue(lerpColor(background, foreground, 0.3))
     .setColorValueLabel(lerpColor(background, foreground, 0.3))
     .setColorCaptionLabel(foreground); 
   cp5.get(Bang.class, "Temperature View")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
   cp5.get(Bang.class, "Frequency View")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
   cp5.get(Bang.class, "Date View")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
   cp5.get(Bang.class, "Toggle Color Search")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
   cp5.get(Bang.class, "Toggle Auto Rotation")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
   cp5.get(Bang.class, "Invert Colors")
     .setColorForeground(color(foreground, 200))
     .setColorBackground(background)
     .setColorCaptionLabel(foreground);
}

// Dropdown select function
void dropdown(int n) {
  ///* request the selected item based on index n */
  cp5.get(Textfield.class, "input").setText((String)cp5.get(ScrollableList.class, "dropdown").getItem(n).get("name"));
  
  /* here an item is stored as a Map  with the following key-value pairs:
   * name, the given name of the item
   * text, the given text of the item by default the same as name
   * value, the given value of the item, can be changed by using .getItem(n).put("value", "abc"); a value here is of type Object therefore can be anything
   * color, the given color of the item, how to change, see below
   * view, a customizable view, is of type CDrawable 
   */
  
   CColor c = new CColor();
  c.setBackground(color(255,0,0));
  cp5.get(ScrollableList.class, "dropdown").getItem(n).put("color", c);
}